/*******************************************************************************
 *  Copyright CONSORTIUM COCKTAIL (www.cocktail.org), 1995, 2008
 *  
 *  This software is governed by the CeCILL license under French law and abiding
 *  by the rules of distribution of free software. You can use, modify and/or
 *  redistribute the software under the terms of the CeCILL license as circulated
 *  by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".
 *  
 *  As a counterpart to the access to the source code and rights to copy, modify
 *  and redistribute granted by the license, users are provided only with a
 *  limited warranty and the software's author, the holder of the economic
 *  rights, and the successive licensors have only limited liability.
 *  
 *  In this respect, the user's attention is drawn to the risks associated with
 *  loading, using, modifying and/or developing or reproducing the software by
 *  the user in light of its specific status of free software, that may mean that
 *  it is complicated to manipulate, and that also therefore means that it is
 *  reserved for developers and experienced professionals having in-depth
 *  computer knowledge. Users are therefore encouraged to load and test the
 *  software's suitability as regards their requirements in conditions enabling
 *  the security of their systems and/or data to be ensured and, more generally,
 *  to use and operate it in the same conditions as regards security.
 *  
 *  The fact that you are presently reading this means that you have had
 *  knowledge of the CeCILL license and that you accept its terms.
 * 
 *******************************************************************************/

package org.cocktail.kaki.client.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.application.client.eof.EOOrgan;
import org.cocktail.application.client.swing.TableSorter;
import org.cocktail.application.client.swing.ZEOTable;
import org.cocktail.application.client.swing.ZEOTableModel;
import org.cocktail.application.client.swing.ZEOTableModelColumn;
import org.cocktail.application.serveur.eof.EOExercice;
import org.cocktail.kaki.common.KakiIcones;
import org.cocktail.kaki.server.metier.EOVExtourneCreditsCr;
import org.cocktail.kaki.server.metier.EOVExtourneCreditsUb;

import com.webobjects.eointerface.EODisplayGroup;

/**
 *
 * @author  cpinsard
 */
public class EnveloppesSelectView extends javax.swing.JDialog {

        /**
	 * 
	 */
	private static final long serialVersionUID = 75089577772567331L;
		protected EODisplayGroup eodUb, eodCr;
	protected ZEOTable myEOTableUb, myEOTableCr;
	protected ZEOTableModel myTableModelUb, myTableModelCr;
	protected TableSorter myTableSorterUb, myTableSorterCr;

    
    /** Creates new form TemplateJDialog */
    public EnveloppesSelectView(java.awt.Frame parent, boolean modal, EODisplayGroup dgUb, EODisplayGroup dgCr) {
        super(parent, modal);

        eodUb = dgUb;
        eodCr = dgCr;
        
        initComponents();
        initGui();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        viewTableUb = new javax.swing.JPanel();
        btnFermer = new javax.swing.JButton();
        viewTableCr = new javax.swing.JPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Sélection Types de Crédit");
        setResizable(false);

        viewTableUb.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        viewTableUb.setLayout(new java.awt.BorderLayout());

        btnFermer.setToolTipText("Valider la sélection");
        btnFermer.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnFermerActionPerformed(evt);
            }
        });

        viewTableCr.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        viewTableCr.setLayout(new java.awt.BorderLayout());

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(viewTableCr, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 605, Short.MAX_VALUE)
                    .add(viewTableUb, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 605, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, btnFermer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 50, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(viewTableUb, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 145, Short.MAX_VALUE)
                .add(18, 18, 18)
                .add(viewTableCr, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 153, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(btnFermer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-641)/2, (screenSize.height-403)/2, 641, 403);
    }// </editor-fold>//GEN-END:initComponents

    private void btnFermerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnFermerActionPerformed

        dispose();
    }//GEN-LAST:event_btnFermerActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                EnveloppesSelectView dialog = new EnveloppesSelectView(new javax.swing.JFrame(), true, null, null);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnFermer;
    private javax.swing.JPanel viewTableCr;
    private javax.swing.JPanel viewTableUb;
    // End of variables declaration//GEN-END:variables

	private void initGui() {
            	
    	setTitle("Visualisation des enveloppes d'extourne");
    	btnFermer.setIcon(KakiIcones.ICON_CLOSE);
        
		Vector<ZEOTableModelColumn> myCols = new Vector<ZEOTableModelColumn>();

    	ZEOTableModelColumn	col = new ZEOTableModelColumn(eodUb, EOVExtourneCreditsUb.EXERCICE_KEY+"."+EOExercice.EXE_EXERCICE_KEY, "Année", 50);
    	col.setAlignment(SwingConstants.CENTER);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eodUb, EOVExtourneCreditsUb.TO_ORGAN_UB_KEY+"."+EOOrgan.ORG_UB_KEY, "UB", 60);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eodUb, EOVExtourneCreditsUb.VEC_MONTANT_BUD_INITIAL_KEY, "Initial", 100);
    	col.setAlignment(SwingConstants.RIGHT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eodUb, EOVExtourneCreditsUb.VEC_MONTANT_BUD_CONSOMME_KEY, "Consomme", 100);
    	col.setAlignment(SwingConstants.RIGHT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eodUb, EOVExtourneCreditsUb.VEC_MONTANT_BUD_DISPO_REEL_KEY, "Disponible", 100);
    	col.setAlignment(SwingConstants.RIGHT);
    	myCols.add(col);

		myTableModelUb = new ZEOTableModel(eodUb, myCols);
		myTableSorterUb = new TableSorter(myTableModelUb);

		myEOTableUb = new ZEOTable(myTableSorterUb);
		myTableSorterUb.setTableHeader(myEOTableUb.getTableHeader());		

		myEOTableUb.setBackground(new Color(230, 230, 230));
		myEOTableUb.setSelectionBackground(new Color(127,155,165));
		myEOTableUb.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		
		viewTableUb.setLayout(new BorderLayout());
		viewTableUb.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTableUb.removeAll();
		viewTableUb.add(new JScrollPane(myEOTableUb), BorderLayout.CENTER);

		
		myCols = new Vector<ZEOTableModelColumn>();

    	col = new ZEOTableModelColumn(eodCr, EOVExtourneCreditsCr.TO_ORGAN_CR_KEY+"."+EOOrgan.ORG_UB_KEY, "UB", 60);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eodCr, EOVExtourneCreditsCr.TO_ORGAN_CR_KEY+"."+EOOrgan.ORG_CR_KEY, "CR", 60);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eodCr, EOVExtourneCreditsCr.VEC_MONTANT_BUD_INITIAL_KEY, "Initial", 100);
    	col.setAlignment(SwingConstants.RIGHT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eodCr, EOVExtourneCreditsCr.VEC_MONTANT_BUD_CONSOMME_KEY, "Consomme", 100);
    	col.setAlignment(SwingConstants.RIGHT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eodCr, EOVExtourneCreditsCr.VEC_MONTANT_BUD_DISPO_REEL_KEY, "Disponible", 100);
    	col.setAlignment(SwingConstants.RIGHT);
    	myCols.add(col);

		myTableModelCr = new ZEOTableModel(eodCr, myCols);
		myTableSorterCr = new TableSorter(myTableModelCr);

		myEOTableCr = new ZEOTable(myTableSorterCr);
		myTableSorterCr.setTableHeader(myEOTableCr.getTableHeader());		

		myEOTableCr.setBackground(new Color(230, 230, 230));
		myEOTableCr.setSelectionBackground(new Color(127,155,165));
		myEOTableCr.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		
		viewTableCr.setLayout(new BorderLayout());
		viewTableCr.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTableCr.removeAll();
		viewTableCr.add(new JScrollPane(myEOTableCr), BorderLayout.CENTER);

    }

	public ZEOTable getMyEOTableUb() {
		return myEOTableUb;
	}

	public void setMyEOTableUb(ZEOTable myEOTableUb) {
		this.myEOTableUb = myEOTableUb;
	}

	public ZEOTable getMyEOTableCr() {
		return myEOTableCr;
	}

	public void setMyEOTableCr(ZEOTable myEOTableCr) {
		this.myEOTableCr = myEOTableCr;
	}

	public javax.swing.JButton getBtnFermer() {
		return btnFermer;
	}

	public void setBtnFermer(javax.swing.JButton btnFermer) {
		this.btnFermer = btnFermer;
	}

	
}
